import java.util.*;
public class MyClass {
	// este es el único método que tienen que desarrollar
	// para hacerlo, pueden hacer uso de otras clases (si es necesario),
	// pero la corrección del ejercicio será automática en base a este
	// método que está acá
	public String ganadores(List<Carta[]> jugadas){
		//Imprime la cantidad de jugadas
		System.out.println("Cantidad de jugadas: " + jugadas.size());
		//Imprime las jugadas
		int i = 1;
		for (Carta[] mano : jugadas) {
			System.out.println("JUGADA "+ i+ " ======================");
			for (Carta c : mano) {
				System.out.println(c.valorPalo());
			}
			i= i+1;
		}
		//Vamos a establecer el tipo de mano que tiene cada mano
		//Cada tipo de mano le corresponde un número
		int[] manos = new int[jugadas.size()];
		int indice = 0;
		Clasificador clasifica = new Clasificador();
		for (Carta[] mano : jugadas) {
			manos[indice] = clasifica.jugada(mano);
			indice = indice +1;
		}
		//De estas manos, tengo que saber cual es el ganador
		//Vamos a hallar la mayor tipo de jugada
		int mejor = 8;
		for(int indice1 = 0;indice1<manos.length;indice1++) {
			if(manos[indice1]<mejor) {
				mejor=manos[indice1];
			}
		}
		//Ahora averiguamos cuales manos quitaron la mejor tipo de mano
		ArrayList<Integer> mejoresManos= new ArrayList<>();
		for(int indice1=0;indice1<manos.length;indice1++) {
			if(mejor==manos[indice1]) {
				mejoresManos.add(indice1);
			}
		}
		//Ahora vamos a imprimir el ganador
		if(mejoresManos.size()==1) {
			return "Jugada "+(mejoresManos.get(0)+1);
		//Esto es en caso que haya varias manos
		}else {
			//Vamos crear una lista de manos
			ArrayList<Carta[]> variasManos = new ArrayList<>();
			//Cargamos en la lista las mejores manos
			for(int indice1=0;indice1<mejoresManos.size();indice1++) {
				variasManos.add(jugadas.get(mejoresManos.get(indice1)));
			}
			//Utilizaremos el objeto SelectorGanador para obtener la mano ganadora
			SelectorGanador manoGanador = new SelectorGanador(variasManos,mejor);
			//Obtenemos la mano ganadora
			Carta[] ganador = manoGanador.procesar();
			//Buscamos en que jugada se uso
			for(int indice1 = 0;indice1<jugadas.size();indice1++) {
				if(ganador == jugadas.get(indice1)) {
					return "Jugada "+(indice1 + 1);
				}
			}
		}
		return "Error";
	}
	
	public static void main(String args[]) {
		int x=10;
		int y=25;
		int z=x+y;
		MyClass mc = new MyClass();
		List<Carta[]> jugadas = new ArrayList<Carta[]>();
		Carta[] m1 = new Carta[5];
		 m1[0] = new Carta("AH");
		 m1[1] = new Carta("2H");
		 m1[2] = new Carta("4H");
		 m1[3] = new Carta("6H");
		 m1[4] = new Carta("5H");
		 Carta[] m2 = new Carta[5];
		 m2[0] = new Carta("AH");
		 m2[1] = new Carta("TH");
		 m2[2] = new Carta("KH");
		 m2[3] = new Carta("QH");
		 m2[4] = new Carta("JH");
		 Carta[] m3 = new Carta[5];
		 m3[0] = new Carta("3D");
		 m3[1] = new Carta("4D");
		 m3[2] = new Carta("5D");
		 m3[3] = new Carta("8D");
		 m3[4] = new Carta("9D");
		 jugadas.add(m1);
		 jugadas.add(m2);
		 jugadas.add(m3);
		String ganadores = mc.ganadores(jugadas);
		System.out.println("Sum of x+y = " + z);
		System.out.println("Ganadores = " + ganadores);
	}
	
}
